////////////////////////////////////////////////////////////////////////
//
// 46-927 Data Structures, Algorithms and AI
//
// File: Key.h
//
// Author:        Jeff Stephenson        
// Date:          August 22, 1998  
// Comments:      Supporting Code for Assignment #1
//                Declaration of the CKey class 
//                See Key.cpp
//
//                This implementation of the CKey class is
//                a data structure that contains the following
//                member variables:
//
//                int m_time -- the time value
//	              double m_stock_price -- the stock price at this time
//                double m_aux_process -- the value of the aux_process at this time
//	              double m_option_value -- the option value at this time
// 
//                Provided are access functions, a printing function, 
//                an equality testing function, and an overloaded assignment operator.
//
////////////////////////////////////////////////////////////////////////


#ifndef KEY_H
#define KEY_H

class CKey  
{
public:
    CKey(); 
	CKey(int pTime, double pPrice, double pProcess);
	virtual ~CKey();

    void   PrintKey();
    bool   IsEqual(CKey aKey);

	int    GetTime();
	void   SetTime(int pTime);

    double GetStockPrice();
    void   SetStockPrice(double pPrice);

    double GetAuxProcess();
    void   SetAuxProcess(double pProcess);

    double GetOptionValue();
    void   SetOptionValue(double pOptValue);

    CKey&  operator=(const CKey& aKey);



protected:

	int m_time;
	double m_stock_price;
	double m_aux_process;
	double m_option_value;

};

#endif
