////////////////////////////////////////////////////////////////////////
//
// 46-927 Data Structures, Algorithms and AI
//
// File: LinkedList.h
//
// Author:        Jeff Stephenson         
// Date:          August 22, 1998
// Comments:      Declaration of the CLinkedList class
//                
//
//                See LinkedList.cpp for more detail
// 
////////////////////////////////////////////////////////////////////////

#ifndef LINKEDLIST_H
#define LINKEDLIST_H

#include "Key.h"
#include "Node.h"

class CLinkedList  
{
public:
	CLinkedList();
	virtual ~CLinkedList();

    CNode* InsertAtHead(CKey aKey);
    CNode* InsertAtTail(CKey aKey);
    int  CountNodes();
    CNode* Search(CKey aKey);
    CNode* InsertUnique(CKey aKey);
    void PrintList();
    bool RemoveFromHead(CKey& retVal);

    CNode* m_head;
    CNode* m_tail;
    int   m_count;
};

#endif 
