////////////////////////////////////////////////////////////////////////
//
// 46-927 Data Structures, Algorithms and AI
//
// File: LookBackOption.h
//
// Author:        Jeff Stephenson        
// Date:          September 17, 1998  
// Comments:      Declaration of the CLookBackOption class
//
//                A class derived from CAbstractOption for
//                pricing LookBack Options.
//
//                We have added a member variable for the strike price 
//                (m_strike_price).  
//
//                You must write the F(), Payoff(), and MonteCarloPath()
//                functions.
//
//                See LookBackOptions.cpp for more detail on the assignment.
// 
////////////////////////////////////////////////////////////////////////


#ifndef LOOKBACKOPT_H
#define LOOKBACKOPT_H

#include "AbstractOption.h"

class CLookBackOption : public CAbstractOption  
{
public:
	CLookBackOption(int T, 
                        double r, 
                        double u, 
                        double d, 
                        double s_0);

    CLookBackOption(int T, 
                        double r, 
                        double u, 
                        double d, 
                        double s_0,
                        double strike);

	virtual ~CLookBackOption();

    void SetStrikePrice(double strike);

    /* You must write these functions */
    double F(double s, double x);
    double Payoff(double s, double x, int t);

private:

    double m_strike_price;

};

#endif 